#-----------------------------------------------------------------------------
# DelFigs
# Copyright (c) 2005 David G. Drumright (Ockham)
# Jan 21, 2005
# Delete the selected Figures.
#-----------------------------------------------------------------------------

from Tkinter import *
import poser
scene = poser.Scene()

#-----------------------------------------------------------------------------
# Next section is TK
#------------------------------------------------------------

class App:
    def __init__(self, master, textMessage):
        self.master = master
        master.title("Fig deleter")

        self.Labelbox = Label(self.master,text="Highlight figures in list, then hit Delete").grid(row=1, column=0,columnspan=3)

        # Lists
        self.ListScroll = Scrollbar(self.master, orient=VERTICAL)
        self.ListScroll.grid( row=2, column=0,sticky=N+S+E)
        self.List = Listbox(self.master, height=5, selectmode=MULTIPLE,yscrollcommand = self.ListScroll.set)
        self.List.grid( row=2, column=1)
        # Set the scrollbar to work
        self.ListScroll["command"] = self.List.yview
        # Fill list with all PP2 in the scene
        for OneFigure in scene.Figures():
            Name=OneFigure.Name()
            self.List.insert(END,Name)

        # Go/nogo buttons.
        self.buttonGo = Button(self.master, text="Delete", command=self.HandleGo)
        self.buttonGo.grid(row=3, column=0)

        self.buttonCancel = Button(self.master, text="Cancel", command=self.HandleCancel)
        self.buttonCancel.grid(row=3, column=2)

        self.master.protocol('WM_DELETE_WINDOW', self.HandleCancel)


    # - - - - - - - - - - - - - - - - - -

    def Update(self):
        if scene: scene.ProcessSomeEvents()
        root.lift()
        root.after(100, self.Update)

    # - - - - - - - - - - - - - - - - - -

    def HandleGo(self):
        # Go through selected items.  For each, find all of its childs and delete them.
        Sels=self.List.curselection()
        if not Sels:  # Do all in list
            for OneIndex in range(self.List.size()):
                FigName=self.List.get(OneIndex)
                TheFig=scene.Figure(FigName)
                scene.SelectFigure(TheFig)
                scene.DeleteCurrentFigure()
        else: # Sels
            for OneIndex in Sels:
                FigName=self.List.get(int(OneIndex))
                TheFig=scene.Figure(FigName)
                scene.SelectFigure(TheFig)
                scene.DeleteCurrentFigure()

        self.master.destroy()

    # - - - - - - - - - - - - - - - - - -

    def HandleCancel(self):
        self.master.destroy()

#------------------------------------------------------------
# Activate the loop
#------------------------------------------------------------

root = Tk()
app = App(root, '')
app.Update()
root.mainloop()

#------------------------------------------------------------
# End TK loop.
#-----------------------------------------------------------------------------
